%global momorel 2
%global emacsver 23.0.95
%global xemacsver 21.5.29
%global e_sitedir %{_datadir}/emacs/site-lisp
#%%global xe_sitedir  %{_datadir}/xemacs/site-lisp
%global sitepdir  %{_datadir}/xemacs/site-packages

%{!?ruby_sitelibdir: %define ruby_sitelibdir %(ruby -rrbconfig -e 'puts Config::CONFIG["sitelibdir"]')}
%define pbuild %{_builddir}/%{name}-%{version}
%define confdir conf/redhat

%global vimver 71
%global vimmacrodir %{_datadir}/vim/vim%{vimver}/syntax/

Summary: A network tool for managing many disparate systems
Name: puppet
Version: 0.24.8
Release: %{momorel}m%{?dist}
License: GPLv2+
Group: System Environment/Base
URL: http://puppet.reductivelabs.com/
Source0: http://reductivelabs.com/downloads/puppet/%{name}-%{version}.tgz
NoSource: 0
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: facter >= 1.5
BuildRequires: ruby >= 1.8.1
%ifnarch ppc64
BuildRequires:  emacs >= %{emacsver}, xemacs >= %{xemacsver}, xemacs-sumo
%endif
BuildArch: noarch
Requires: ruby(abi) = 1.8
Requires: ruby-shadow
Requires: libselinux-ruby
Requires: facter >= 1.5
Requires: ruby >= 1.8.1
Requires: ruby-augeas
Requires(pre): shadow-utils
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(preun): initscripts
Requires(postun): initscripts

%description
Puppet lets you centrally manage every important aspect of your system using a 
cross-platform specification language that manages all the separate elements 
normally aggregated in different files, like users, cron jobs, and hosts, 
along with obviously discrete elements like packages, services, and files.

%package server
Group: System Environment/Base
Summary: Server for the puppet system management tool
Requires: puppet = %{version}-%{release}
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(preun): initscripts
Requires(postun): initscripts

%description server
Provides the central puppet server daemon which provides manifests to clients.
The server can also function as a certificate authority and file server.

%ifnarch ppc64
%package emacs
Summary: Emacs Lisp puppet-mode for puppet manifest
Group: Applications/Editors
Requires: emacs >= %{emacsver}

%description emacs
Emacs Lisp puppet-mode for puppet manifest

%package xemacs
Summary: Emacs Lisp puppet-mode for puppet manifest
Group: Applications/Editors
Requires: xemacs >= %{xemacsver}

%description xemacs
XEmacs Lisp puppet-mode for puppet manifest
%endif

%package vim
Summary: VIM macro for puppet manifest
Group: Applications/Editors
Requires: vim-macros >= 7.1

%description vim
VIM macro for puppet manifest

%prep
%setup -q

# Move puppetca, puppetd, and puppetmasterd to sbin
mkdir sbin
mv bin/puppet{ca,d,masterd} sbin/

%build
# Fix some rpmlint complaints
for f in mac_dscl.pp mac_dscl_revert.pp \
         mac_netinfo.pp mac_pkgdmg.pp ; do
  sed -i -e'1d' examples/$f
  chmod a-x examples/$f
done
for f in external/nagios.rb network/http_server/mongrel.rb relationship.rb; do
  sed -i -e '1d' lib/puppet/$f
done

find examples/ -type f -empty | xargs rm
find examples/ -type f | xargs chmod a-x

%install
rm -rf %{buildroot}
ruby install.rb --destdir=%{buildroot} --quick --no-rdoc

install -d -m0755 %{buildroot}%{_sysconfdir}/puppet/manifests
install -d -m0755 %{buildroot}%{_localstatedir}/lib/puppet
install -d -m0755 %{buildroot}%{_localstatedir}/run/puppet
install -d -m0755 %{buildroot}%{_localstatedir}/log/puppet
install -Dp -m0644 %{confdir}/client.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/puppet
install -Dp -m0755 %{confdir}/client.init %{buildroot}%{_initscriptdir}/puppet
install -Dp -m0644 %{confdir}/server.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/puppetmaster
install -Dp -m0755 %{confdir}/server.init %{buildroot}%{_initscriptdir}/puppetmaster
install -Dp -m0644 %{confdir}/fileserver.conf %{buildroot}%{_sysconfdir}/puppet/fileserver.conf
install -Dp -m0644 %{confdir}/puppet.conf %{buildroot}%{_sysconfdir}/puppet/puppet.conf
install -Dp -m0644 %{confdir}/logrotate %{buildroot}%{_sysconfdir}/logrotate.d/puppet

# We need something for these ghosted files, otherwise rpmbuild
# will complain loudly. They won't be included in the binary packages
touch %{buildroot}%{_sysconfdir}/puppet/puppetmasterd.conf
touch %{buildroot}%{_sysconfdir}/puppet/puppetca.conf
touch %{buildroot}%{_sysconfdir}/puppet/puppetd.conf

## emacs lisp
%ifnarch ppc64
mkdir -p %{buildroot}%{e_sitedir}
mkdir -p %{buildroot}%{e_sitedir}/site-start.d
mkdir -p %{buildroot}%{sitepdir}/lisp

cp ext/emacs/puppet-mode.el %{buildroot}%{e_sitedir}
cp ext/emacs/puppet-mode.el %{buildroot}%{sitepdir}/lisp
cp ext/emacs/*init.el %{buildroot}%{e_sitedir}/site-start.d

pushd %{buildroot}%{e_sitedir}
  emacs -batch -q -no-site-file -eval "(add-to-list 'load-path \".\")" \
    -f batch-byte-compile *.el
popd

pushd %{buildroot}%{sitepdir}/lisp
  xemacs -batch -q -no-site-file -eval "(add-to-list 'load-path \".\")" \
    -f batch-byte-compile *.el
popd
%endif

## VIM macro
mkdir -p %{buildroot}%{vimmacrodir}/{ftdetect,syntax}
cp ext/vim/ftdetect/puppet.vim %{buildroot}%{vimmacrodir}/ftdetect/
cp ext/vim/syntax/puppet.vim %{buildroot}%{vimmacrodir}/syntax/

## ldap schema
mkdir -p %{buildroot}%{_sysconfdir}/openldap/schema
cp ext/ldap/puppet.schema %{buildroot}%{_sysconfdir}/openldap/schema/

%files
%defattr(-, root, root, 0755)
%{_bindir}/puppet
%{_bindir}/ralsh
%{_bindir}/filebucket
%{_bindir}/puppetdoc
%exclude %{_mandir}/man8/pi.8*
%{_sbindir}/puppetd
%{ruby_sitelibdir}/*
%{_initscriptdir}/puppet
%dir %{_sysconfdir}/puppet
%config(noreplace) %{_sysconfdir}/sysconfig/puppet
%config(noreplace) %{_sysconfdir}/puppet/puppet.conf
%ghost %config(noreplace,missingok) %{_sysconfdir}/puppet/puppetd.conf
%{_sysconfdir}/openldap/schema/puppet.schema
%doc CHANGELOG COPYING LICENSE README examples
%config(noreplace) %{_sysconfdir}/logrotate.d/puppet
# These need to be owned by puppet so the server can
# write to them
%attr(-, puppet, puppet) %{_localstatedir}/run/puppet
%attr(-, puppet, puppet) %{_localstatedir}/log/puppet
%attr(-, puppet, puppet) %{_localstatedir}/lib/puppet
%doc %{_mandir}/man8/puppet.8*
%doc %{_mandir}/man8/puppet.conf.8*
%doc %{_mandir}/man8/puppetd.8*
%doc %{_mandir}/man8/ralsh.8*
%doc %{_mandir}/man8/puppetdoc.8*

%files server
%defattr(-, root, root, 0755)
%{_sbindir}/puppetmasterd
%{_bindir}/puppetrun
%{_initscriptdir}/puppetmaster
%config(noreplace) %{_sysconfdir}/puppet/fileserver.conf
%dir %{_sysconfdir}/puppet/manifests
%config(noreplace) %{_sysconfdir}/sysconfig/puppetmaster
%ghost %config(noreplace,missingok) %{_sysconfdir}/puppet/puppetca.conf
%ghost %config(noreplace,missingok) %{_sysconfdir}/puppet/puppetmasterd.conf
%{_sbindir}/puppetca
%doc %{_mandir}/man8/filebucket.8*
%doc %{_mandir}/man8/puppetca.8*
%doc %{_mandir}/man8/puppetmasterd.8*
%doc %{_mandir}/man8/puppetrun.8*

%ifnarch ppc64
%files emacs
%defattr(-, root, root)
%{e_sitedir}/*.el*
%{e_sitedir}/site-start.d/*init.el

%files xemacs
%defattr(-, root, root)
%{sitepdir}/lisp/*.el*
%endif

%files vim
%defattr(-, root, root)
%{vimmacrodir}/*/*.vim

# Fixed uid/gid were assigned in bz 472073 (Fedora), 471918 (RHEL-5),
# and 471919 (RHEL-4)
%pre
getent group puppet &>/dev/null || groupadd -r puppet -g 52 &>/dev/null
getent passwd puppet &>/dev/null || \
useradd -r -u 52 -g puppet -d %{_localstatedir}/lib/puppet -s /sbin/nologin \
    -c "Puppet" puppet &>/dev/null || :
# ensure that old setups have the right puppet home dir
if [ $1 -gt 1 ] ; then
  usermod -d %{_localstatedir}/lib/puppet puppet &>/dev/null || :
fi

%post
/sbin/chkconfig --add puppet || :

%post server
/sbin/chkconfig --add puppetmaster || :

%preun
if [ "$1" = 0 ] ; then
  /sbin/service puppet stop > /dev/null 2>&1
  /sbin/chkconfig --del puppet || :
fi

%preun server
if [ "$1" = 0 ] ; then
  /sbin/service puppetmaster stop > /dev/null 2>&1
  /sbin/chkconfig --del puppetmaster || :
fi

%postun
if [ "$1" -ge 1 ]; then
  /sbin/service puppet condrestart >/dev/null 2>&1 || :
fi

%postun server
if [ "$1" -ge 1 ]; then
  /sbin/service puppetmaster condrestart > /dev/null 2>&1 || :
fi

%clean
rm -rf %{buildroot}

%changelog
* Sun Jun 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.24.8-2m)
- rebuild against emacs-23.0.95

* Wed Jun  3 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.24.8-1m)
- update to 0.24.8
- drop Source1, manpages included

* Mon May 25 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.24.4-7m)
- rebuild against emacs-23.0.94

* Fri May 22 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.24.4-6m)
- rebuild against xemacs-21.5.29

* Thu Apr  2 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.24.4-5m)
- rebuild against emacs-23.0.92

* Wed Jan 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.24.4-4m)
- rebuild against rpm-4.6

* Thu Jul 24 2008 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.24.4-3m)
- rebuild against xemacs-21.5.28
- use %%{sitepdir}

* Wed Jul 16 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.24.4-2m)
- use %%{_initscriptdir} instead of %%{_initrddir} again

* Wed Jul 16 2008 Masahiro Takahata <takahata@momonga-linux.org>
- (0.24.4-1m)
- sync Fedora

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.23.0-5m)
- rebuild against gcc43

* Wed Nov 14 2007 Mitsuru Shimamura <smbd@momonga-linux.org>
- (0.23.0-4m)
- add emacs lisp, vim script, ldap schema

* Wed Jul 25 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.23.0-3m)
- PreReq: chkconfig, initscripts, shadow-utils

* Mon Jul 23 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.23.0-2m)
- move start up script from %%{_initrddir} to %%{_initscriptdir}

* Sun Jul  8 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (0.23.0-1m)
- update 0.23.0

* Fri Jun 15 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.22.4-2m)
- remove puppetd.conf from puppet-server

* Fri Jun 15 2007 Masahiro Takahata <takahata@momonga-linux.org>
- (0.22.4-1m)
- import from Fedora

* Wed May  2 2007 David Lutterkort <dlutter@redhat.com> - 0.22.4-1
- New version

* Thu Mar 29 2007 David Lutterkort <dlutter@redhat.com> - 0.22.3-1
- Claim ownership of _sysconfdir/puppet (bz 233908)

* Mon Mar 19 2007 David Lutterkort <dlutter@redhat.com> - 0.22.2-1
- Set puppet's homedir to /var/lib/puppet, not /var/puppet
- Remove no-lockdir patch, not needed anymore

* Mon Feb 12 2007 David Lutterkort <dlutter@redhat.com> - 0.22.1-2
- Fix bogus config parameter in puppetd.conf

* Sat Feb  3 2007 David Lutterkort <dlutter@redhat.com> - 0.22.1-1
- New version

* Fri Jan  5 2007 David Lutterkort <dlutter@redhat.com> - 0.22.0-1
- New version

* Mon Nov 20 2006 David Lutterkort <dlutter@redhat.com> - 0.20.1-2
- Make require ruby(abi) and buildarch: noarch conditional for fedora 5 or
  later to allow building on older fedora releases

* Mon Nov 13 2006 David Lutterkort <dlutter@redhat.com> - 0.20.1-1
- New version

* Mon Oct 23 2006 David Lutterkort <dlutter@redhat.com> - 0.20.0-1
- New version

* Tue Sep 26 2006 David Lutterkort <dlutter@redhat.com> - 0.19.3-1
- New version

* Mon Sep 18 2006 David Lutterkort <dlutter@redhat.com> - 0.19.1-1
- New version

* Thu Sep  7 2006 David Lutterkort <dlutter@redhat.com> - 0.19.0-1
- New version

* Tue Aug  1 2006 David Lutterkort <dlutter@redhat.com> - 0.18.4-2
- Use /usr/bin/ruby directly instead of /usr/bin/env ruby in
  executables. Otherwise, initscripts break since pidof can't find the
  right process

* Tue Aug  1 2006 David Lutterkort <dlutter@redhat.com> - 0.18.4-1
- New version

* Fri Jul 14 2006 David Lutterkort <dlutter@redhat.com> - 0.18.3-1
- New version

* Wed Jul  5 2006 David Lutterkort <dlutter@redhat.com> - 0.18.2-1
- New version

* Wed Jun 28 2006 David Lutterkort <dlutter@redhat.com> - 0.18.1-1
- Removed lsb-config.patch and yumrepo.patch since they are upstream now

* Mon Jun 19 2006 David Lutterkort <dlutter@redhat.com> - 0.18.0-1
- Patch config for LSB compliance (lsb-config.patch)
- Changed config moves /var/puppet to /var/lib/puppet, /etc/puppet/ssl 
  to /var/lib/puppet, /etc/puppet/clases.txt to /var/lib/puppet/classes.txt,
  /etc/puppet/localconfig.yaml to /var/lib/puppet/localconfig.yaml

* Fri May 19 2006 David Lutterkort <dlutter@redhat.com> - 0.17.2-1
- Added /usr/bin/puppetrun to server subpackage
- Backported patch for yumrepo type (yumrepo.patch)

* Wed May  3 2006 David Lutterkort <dlutter@redhat.com> - 0.16.4-1
- Rebuilt

* Fri Apr 21 2006 David Lutterkort <dlutter@redhat.com> - 0.16.0-1
- Fix default file permissions in server subpackage
- Run puppetmaster as user puppet
- rebuilt for 0.16.0

* Mon Apr 17 2006 David Lutterkort <dlutter@redhat.com> - 0.15.3-2
- Don't create empty log files in post-install scriptlet

* Fri Apr  7 2006 David Lutterkort <dlutter@redhat.com> - 0.15.3-1
- Rebuilt for new version

* Wed Mar 22 2006 David Lutterkort <dlutter@redhat.com> - 0.15.1-1
- Patch0: Run puppetmaster as root; running as puppet is not ready 
  for primetime

* Mon Mar 13 2006 David Lutterkort <dlutter@redhat.com> - 0.15.0-1
- Commented out noarch; requires fix for bz184199

* Mon Mar  6 2006 David Lutterkort <dlutter@redhat.com> - 0.14.0-1
- Added BuildRequires for ruby

* Wed Mar  1 2006 David Lutterkort <dlutter@redhat.com> - 0.13.5-1
- Removed use of fedora-usermgmt. It is not required for Fedora Extras and
  makes it unnecessarily hard to use this rpm outside of Fedora. Just
  allocate the puppet uid/gid dynamically

* Sun Feb 19 2006 David Lutterkort <dlutter@redhat.com> - 0.13.0-4
- Use fedora-usermgmt to create puppet user/group. Use uid/gid 24. Fixed 
problem with listing fileserver.conf and puppetmaster.conf twice

* Wed Feb  8 2006 David Lutterkort <dlutter@redhat.com> - 0.13.0-3
- Fix puppetd.conf

* Wed Feb  8 2006 David Lutterkort <dlutter@redhat.com> - 0.13.0-2
- Changes to run puppetmaster as user puppet

* Mon Feb  6 2006 David Lutterkort <dlutter@redhat.com> - 0.13.0-1
- Don't mark initscripts as config files

* Mon Feb  6 2006 David Lutterkort <dlutter@redhat.com> - 0.12.0-2
- Fix BuildRoot. Add dist to release

* Tue Jan 17 2006 David Lutterkort <dlutter@redhat.com> - 0.11.0-1
- Rebuild

* Thu Jan 12 2006 David Lutterkort <dlutter@redhat.com> - 0.10.2-1
- Updated for 0.10.2 Fixed minor kink in how Source is given

* Wed Jan 11 2006 David Lutterkort <dlutter@redhat.com> - 0.10.1-3
- Added basic fileserver.conf

* Wed Jan 11 2006 David Lutterkort <dlutter@redhat.com> - 0.10.1-1
- Updated. Moved installation of library files to sitelibdir. Pulled 
initscripts into separate files. Folded tools rpm into server

* Thu Nov 24 2005 Duane Griffin <d.griffin@psenterprise.com>
- Added init scripts for the client

* Wed Nov 23 2005 Duane Griffin <d.griffin@psenterprise.com>
- First packaging
